/*=============================================================================
    Copyright (c) 2004 Reece H. Dunn

    Use, modification and distribution is subject to the Boost Software
    License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
    http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/detail/lightweight_test.hpp>

#include <boost/spirit/phoenix/core.hpp>
#include <boost/spirit/phoenix/utility.hpp>

using namespace boost::phoenix;
using namespace std;

int
main()
{
    // basic tests

    pair<char, int> pair1('a', 7);

    BOOST_TEST(first(arg1)(pair1) == 'a');
    BOOST_TEST(second(arg1)(pair1) == 7);

    // test nested pair types

    pair<pair<int, float>, char> pair2(make_pair(3, 2.135f), 'z');

    BOOST_TEST(first(arg1)(pair2) == make_pair(3, 2.135f));
    BOOST_TEST(first(first(arg1))(pair2) == 3);
    BOOST_TEST(second(first(arg1))(pair2) == 2.135f);
    BOOST_TEST(second(arg1)(pair2) == 'z');

    return boost::report_errors();
}
